# Generated by Django 4.2.19 on 2025-03-02 16:20

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('customers', '0007_customerauth_blocked_customerauth_blocked_at_and_more'),
    ]

    operations = [
        migrations.CreateModel(
            name='IBAgreement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('name', models.CharField(max_length=100)),
                ('description', models.TextField(blank=True)),
                ('is_active', models.BooleanField(default=True)),
            ],
            options={
                'verbose_name': 'IB Agreement',
                'verbose_name_plural': 'IB Agreements',
                'db_table': 'ib_agreements',
            },
        ),
        migrations.CreateModel(
            name='IBViewPermission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('can_view_full_hierarchy', models.BooleanField(default=False)),
                ('created_by', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='created_ib_permissions', to=settings.AUTH_USER_MODEL)),
                ('customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='ib_view_permissions', to='customers.customer')),
            ],
            options={
                'verbose_name': 'IB View Permission',
                'verbose_name_plural': 'IB View Permissions',
                'db_table': 'ib_view_permissions',
            },
        ),
        migrations.CreateModel(
            name='IBCommissionRule',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('commission_type', models.CharField(choices=[('REBATE', 'Rebate'), ('COMMISSION', 'Commission')], help_text='Whether this rule applies to rebates or commissions', max_length=10)),
                ('account_type', models.CharField(blank=True, help_text='NULL means all account types', max_length=50, null=True)),
                ('symbol', models.CharField(blank=True, help_text='NULL means all symbols', max_length=50, null=True)),
                ('calculation_type', models.CharField(choices=[('LOT_BASED', 'Lot Based'), ('PERCENTAGE', 'Percentage'), ('PIP_VALUE', 'Pip Value'), ('TIERED', 'Tiered Volume')], max_length=20)),
                ('value', models.DecimalField(decimal_places=5, help_text='Amount per lot/percentage/pip', max_digits=20)),
                ('min_amount', models.DecimalField(decimal_places=5, help_text='Minimum commission amount', max_digits=20)),
                ('max_amount', models.DecimalField(decimal_places=5, help_text='Maximum commission amount', max_digits=20)),
                ('min_trade_time', models.IntegerField(default=0, help_text='Minimum trade duration in seconds (anti-scalping)')),
                ('conditions', models.JSONField(blank=True, default=dict, help_text='Additional conditions (volume ranges, etc)')),
                ('priority', models.IntegerField(default=10, help_text='Rule priority (lower number = higher priority)')),
                ('agreement', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='commission_rules', to='ib_commission.ibagreement')),
            ],
            options={
                'verbose_name': 'IB Commission Rule',
                'verbose_name_plural': 'IB Commission Rules',
                'db_table': 'ib_commission_rules',
            },
        ),
        migrations.CreateModel(
            name='IBAgreementMember',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('is_self_rebate', models.BooleanField(default=False, help_text='Whether the IB can receive rebates from their own trading')),
                ('start_date', models.DateTimeField()),
                ('end_date', models.DateTimeField(blank=True, null=True)),
                ('is_active', models.BooleanField(default=True)),
                ('agreement', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='members', to='ib_commission.ibagreement')),
                ('customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='ib_agreements', to='customers.customer')),
            ],
            options={
                'verbose_name': 'IB Agreement Member',
                'verbose_name_plural': 'IB Agreement Members',
                'db_table': 'ib_agreement_members',
            },
        ),
        migrations.CreateModel(
            name='IBAccountAgreement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('mt5_login', models.IntegerField(help_text='Specific MT5 account login')),
                ('is_self_rebate', models.BooleanField(default=False)),
                ('start_date', models.DateTimeField()),
                ('end_date', models.DateTimeField(blank=True, null=True)),
                ('is_active', models.BooleanField(default=True)),
                ('agreement', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='account_agreements', to='ib_commission.ibagreement')),
                ('customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='account_ib_agreements', to='customers.customer')),
                ('ib_customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='ib_account_agreements', to='customers.customer')),
            ],
            options={
                'verbose_name': 'IB Account Agreement',
                'verbose_name_plural': 'IB Account Agreements',
                'db_table': 'ib_account_agreements',
            },
        ),
        migrations.CreateModel(
            name='CommissionTracking',
            fields=[
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('deal_ticket', models.BigIntegerField(primary_key=True, serialize=False)),
                ('mt5_login', models.IntegerField(help_text='MT5 login that generated the deal')),
                ('commission_type', models.CharField(choices=[('REBATE', 'Rebate'), ('COMMISSION', 'Commission')], max_length=10)),
                ('amount', models.DecimalField(decimal_places=5, max_digits=20)),
                ('processed_time', models.DateTimeField()),
                ('trade_open_time', models.DateTimeField()),
                ('trade_close_time', models.DateTimeField()),
                ('customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='commissions_generated', to='customers.customer')),
                ('direct_ib_customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='direct_commissions', to='customers.customer')),
                ('rule', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='commissions', to='ib_commission.ibcommissionrule')),
            ],
            options={
                'verbose_name': 'Commission Tracking',
                'verbose_name_plural': 'Commission Tracking',
                'db_table': 'commission_tracking',
            },
        ),
        migrations.CreateModel(
            name='CommissionDistribution',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('mt5_login', models.IntegerField(help_text="IB's MT5 login")),
                ('amount', models.DecimalField(decimal_places=5, max_digits=20)),
                ('level', models.IntegerField(help_text='IB level in the hierarchy')),
                ('distribution_type', models.CharField(choices=[('REBATE', 'Rebate'), ('COMMISSION', 'Commission')], max_length=10)),
                ('processed_time', models.DateTimeField()),
                ('customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='commission_distributions', to='customers.customer')),
                ('deal_ticket', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='distributions', to='ib_commission.commissiontracking')),
            ],
            options={
                'verbose_name': 'Commission Distribution',
                'verbose_name_plural': 'Commission Distributions',
                'db_table': 'commission_distribution',
            },
        ),
        migrations.CreateModel(
            name='ClientIBMapping',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('ib_path', models.TextField(help_text='Full path of IBs using customer ids')),
                ('mt5_login', models.IntegerField(help_text="Client's MT5 login")),
                ('customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='client_ib_mappings', to='customers.customer')),
                ('direct_ib_customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='direct_clients', to='customers.customer')),
                ('master_ib_customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='all_hierarchy_clients', to='customers.customer')),
            ],
            options={
                'verbose_name': 'Client IB Mapping',
                'verbose_name_plural': 'Client IB Mappings',
                'db_table': 'client_ib_mapping',
            },
        ),
        migrations.CreateModel(
            name='IBHierarchy',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('level', models.IntegerField(help_text='0 for master IB, increments for each level down')),
                ('path', models.TextField(help_text='Stored as dot-separated customer ids, e.g., "1001.1002.1003"')),
                ('mt5_login', models.IntegerField(help_text='MT5 login for deal processing')),
                ('is_active', models.BooleanField(default=True)),
                ('customer', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='ib_hierarchy', to='customers.customer')),
                ('parent_customer', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='child_ibs', to='customers.customer')),
            ],
            options={
                'verbose_name': 'IB Hierarchy',
                'verbose_name_plural': 'IB Hierarchies',
                'db_table': 'ib_hierarchy',
                'indexes': [models.Index(fields=['mt5_login'], name='ib_hierarch_mt5_log_6732d3_idx'), models.Index(fields=['path'], name='ib_hierarch_path_2dc12e_idx')],
            },
        ),
        migrations.AddIndex(
            model_name='ibcommissionrule',
            index=models.Index(fields=['agreement', 'priority'], name='ib_commissi_agreeme_27a689_idx'),
        ),
        migrations.AddIndex(
            model_name='ibcommissionrule',
            index=models.Index(fields=['account_type', 'symbol'], name='ib_commissi_account_76e731_idx'),
        ),
        migrations.AddIndex(
            model_name='ibcommissionrule',
            index=models.Index(fields=['commission_type'], name='ib_commissi_commiss_4e605a_idx'),
        ),
        migrations.AddConstraint(
            model_name='ibcommissionrule',
            constraint=models.UniqueConstraint(fields=('agreement', 'commission_type', 'account_type', 'symbol', 'calculation_type'), name='unique_commission_rule_config'),
        ),
        migrations.AddIndex(
            model_name='ibaccountagreement',
            index=models.Index(fields=['mt5_login'], name='ib_account__mt5_log_b8a4b9_idx'),
        ),
        migrations.AddIndex(
            model_name='ibaccountagreement',
            index=models.Index(fields=['customer'], name='ib_account__custome_f687ce_idx'),
        ),
        migrations.AddConstraint(
            model_name='ibaccountagreement',
            constraint=models.UniqueConstraint(fields=('mt5_login', 'ib_customer'), name='unique_account_ib_agreement'),
        ),
        migrations.AddIndex(
            model_name='commissiontracking',
            index=models.Index(fields=['mt5_login'], name='commission__mt5_log_8914b0_idx'),
        ),
        migrations.AddIndex(
            model_name='commissiontracking',
            index=models.Index(fields=['customer'], name='commission__custome_d52e72_idx'),
        ),
        migrations.AddIndex(
            model_name='commissiontracking',
            index=models.Index(fields=['direct_ib_customer'], name='commission__direct__1e1dfb_idx'),
        ),
        migrations.AddIndex(
            model_name='commissiontracking',
            index=models.Index(fields=['processed_time'], name='commission__process_fc9fe6_idx'),
        ),
        migrations.AddIndex(
            model_name='commissiondistribution',
            index=models.Index(fields=['mt5_login'], name='commission__mt5_log_b7d329_idx'),
        ),
        migrations.AddIndex(
            model_name='commissiondistribution',
            index=models.Index(fields=['customer'], name='commission__custome_fe81ac_idx'),
        ),
        migrations.AddIndex(
            model_name='commissiondistribution',
            index=models.Index(fields=['processed_time'], name='commission__process_f76d89_idx'),
        ),
        migrations.AddConstraint(
            model_name='commissiondistribution',
            constraint=models.UniqueConstraint(fields=('deal_ticket', 'customer'), name='unique_distribution_per_ib'),
        ),
        migrations.AddIndex(
            model_name='clientibmapping',
            index=models.Index(fields=['mt5_login'], name='client_ib_m_mt5_log_0c41fe_idx'),
        ),
        migrations.AddIndex(
            model_name='clientibmapping',
            index=models.Index(fields=['customer'], name='client_ib_m_custome_21b923_idx'),
        ),
    ]
